View Issue Details

IDProjectCategoryView StatusLast Update
0000359AlmaLinux-9kernelpublic2023-01-23 10:47
Reportertchristian Assigned To 
PrioritynormalSeverityminorReproducibilityalways
Status newResolutionopen 
PlatformDell Optiplex 7050OSAlmaLinuxOS Version9.1
Summary0000359: Reboot/Poweroff hangs with "block device autoloading is deprecated and will be removed" message
DescriptionContext:
AlmaLinux 9.1 updated to latest version (all packages updated, including kernel).
Boot and OS installed on a md raid (mdadm) using an SSD (sata) and a NVME module (M2).
MDADM is not broken, but it does not behave as expected.

Behavior:
System hangs for a few minutes repeating this message several times: "block device autoloading is deprecated and will be removed". After a while, the system proceeds to reboot/poweroff.

Apparently, there was a modification in kernel (current version of Alma) that was fixed in further versions of kernel (6.x). There is a kernel patch to support block device autoloading (assuming that mdadm will not remove device autoloading very soon - last updates on mdadm code is 1-2 years old). I see the kernel patch as the only alternative for the moment.
The patch should enable BLOCK_LEGACY_AUTOLOAD in kernel.
Steps To ReproduceInstall Alma 9.1 (latest) on one or more mdadm partitions (both boot and root). Reboot system
Additional InformationThis behavior was observed on multiple linux distros - all were fixed by either applying the patch or updating kernel to 5.18+ or 6.x
Tagskernel, mdadm, patch, poweroff, reboot, system hangs

Activities

toracat

2023-01-22 11:08

reporter   ~0000788

Maybe related to:

https://forums.rockylinux.org/t/shutdown-gets-into-an-infinite-loop-rocky-linux-9-1/8106
https://lkml.org/lkml/2022/8/26/846

Then the patch will be:

https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=4c66a326b5ab784cddd72de07ac5b6210e9e1b06

Is this the one you applied?

tchristian

2023-01-22 13:56

reporter   ~0000789

Thanks for the updates !

As I see it, there are 2 ways to deal with this issue:
1. Either enable BLOCK_LEGACY_AUTOLOAD in kernels 5.14 to 5.18 (since 5.18 the mainstream of kernel reverted to this option to be ON/YES).
2. Apply the patch you mentioned to not freeze the queue even if the legacy option is not ON.

Since the kernel folks re-enabled this option, I would go for the first option.

The main problem here is that Alma is still using kernel 5.14 - this will be resolved by itself once Alma will reach kernel 5.18+

As a workaround, i would suggest re-enabling the option for kernels 5.14-5.18 directly in the kernel configure/build of Alma

What do you think ?

toracat

2023-01-22 17:59

reporter   ~0000790

In Alma 9.1 (kernel-5.14.0-162.6.1.el9_1), BLOCK_LEGACY_AUTOLOAD is indeed enabled.

* Thu Jun 30 2022 Scott Weaver <[email protected]> [5.14.0-120.82.el9]
rhel: configs: enable BLOCK_LEGACY_AUTOLOAD (Ming Lei) [2083917]

* Mon Jun 27 2022 Patrick Talbert <[email protected]> [5.14.0-120.el9]
- block: default BLOCK_LEGACY_AUTOLOAD to y (Ming Lei) [2083917]

In the RHEL (therefore Alma) kernels, the version number can be misleading as a great number of patches are backported.

toracat

2023-01-23 10:47

reporter   ~0000791

I now have a 9.1 kernel set that was built with the patch. It is available here:

https://toracat.org/test/kernel/4c66a32/

Please test if you can. Note that they are not signed and are offered for testing purposes only.

Issue History

Date Modified Username Field Change
2023-01-18 11:17 tchristian New Issue
2023-01-18 11:17 tchristian Tag Attached: kernel
2023-01-18 11:17 tchristian Tag Attached: mdadm
2023-01-18 11:17 tchristian Tag Attached: patch
2023-01-18 11:17 tchristian Tag Attached: poweroff
2023-01-18 11:17 tchristian Tag Attached: reboot
2023-01-18 11:17 tchristian Tag Attached: system hangs
2023-01-22 11:08 toracat Note Added: 0000788
2023-01-22 13:56 tchristian Note Added: 0000789
2023-01-22 17:59 toracat Note Added: 0000790
2023-01-23 10:47 toracat Note Added: 0000791